package IrrigationController;

import java.io.IOException;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import iotrmi.Java.IoTRMICall;
import iotrmi.Java.IoTRMIObject;

import iotcode.interfaces.*;

public class MoistureSensorCallback_CallbackSkeleton implements MoistureSensorCallback {

	private MoistureSensorCallback mainObj;
	private int objectId = 0;
	private String callbackAddress;
	

	public MoistureSensorCallback_CallbackSkeleton(MoistureSensorCallback _mainObj, String _callbackAddress, int _objectId) throws Exception {
		callbackAddress = _callbackAddress;
		mainObj = _mainObj;
		objectId = _objectId;
	}

	public void newReadingAvailable(int sensorId, float moisture, long timeStampOfLastReading) {
		mainObj.newReadingAvailable(sensorId, moisture, timeStampOfLastReading);
	}

	public void ___newReadingAvailable(IoTRMIObject rmiObj) {
		Object[] paramObj = rmiObj.getMethodParams(new Class<?>[] { int.class, float.class, long.class }, 
		new Class<?>[] { null, null, null });
		newReadingAvailable((int) paramObj[0], (float) paramObj[1], (long) paramObj[2]);
	}

	public void invokeMethod(IoTRMIObject rmiObj) throws IOException {
		int methodId = rmiObj.getMethodId();
		switch (methodId) {
			case 0: ___newReadingAvailable(rmiObj); break;
			default: 
			throw new Error("Method Id " + methodId + " not recognized!");
		}
	}

}
